Unit uMain;

{$mode objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, LCLIntf, LCLType,
  Spin;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    bouton_apercu: TButton;
    spin_hauteur_max_heightmap: TFloatSpinEdit;
    spin_angle_rayons: TFloatSpinEdit;
    spin_hauteur_max_rayons: TFloatSpinEdit;
    image_lightmap: TImage;
    image_heightmap: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    spin_ombrage: TSpinEdit;
    Procedure bouton_apercuClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    procedure CreationLightmap(ASrc, ADst: TBitmap; const AVO: integer; const AAR, AHR, AHP: Single);
  private

  public

  End;

Var
  Form1: TForm1;

Implementation

uses
    Math;

{$R *.lfm}

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Begin
     with image_lightmap.Picture do
     begin
          Bitmap := TBitmap.Create;
          Bitmap.PixelFormat := pf24bit;
          Bitmap.SetSize(image_heightmap.Picture.Bitmap.Width, image_heightmap.Picture.Bitmap.Height);
          Bitmap.Canvas.Brush.Color := clWhite;
          Bitmap.Canvas.Pen.Color   := clWhite;
          Bitmap.Canvas.Pen.Width   := 1;
          Bitmap.Canvas.Rectangle(0, 0, Bitmap.Width, Bitmap.Height);
     end;
end;

Procedure TForm1.CreationLightmap(ASrc, ADst: TBitmap; Const AVO: integer;
  Const AAR, AHR, AHP: Single);
var
   x, y, x_rayon: integer;
   z_step, z_origine, z_rayon: single;
   Pixel, Final: PRGBTriple;
Begin
    // Calcul du pas en z pour chaque rayon.
    z_step := abs(1 / tan(AAR));

    ADst.BeginUpdate;

    // Lancement des rayons dans le sens horizontal et de gauche a droite.
    for y := 0 to ADst.Height - 1 do
    begin
         // Pointeurs sur les 2 même lignes des 2 bitmaps.
         Final := PRGBTriple(ASrc.RawImage.GetLineStart(y));
         Pixel := PRGBTriple(ADst.RawImage.GetLineStart(y));

         // Par defaut tout a la valeur de l'ombre défini dans l'UI.
         for x := 0 to ADst.Width - 1 do
         begin
              Pixel[x].rgbtRed   := AVO;
              Pixel[x].rgbtGreen := AVO;
              Pixel[x].rgbtBlue  := AVO;
         End;

         // Lancements des rayons pour chaque hauteur en remontant suivant l'axe z
         z_origine := 0.0;

         while z_origine < AHR do
         begin
              // Lancement de rayon.
              z_rayon := z_origine;

              for x_rayon := 0 to ADst.Width - 1 do
              begin
                   // Si la hauteur (rouge pour l'exmple) du pixel est supérieur ou égale a la valeur
                   // du z_rayon alors on le colorie en blanc et on passe au rayoin lancé suivant.
                   if ((Final[x_rayon].rgbtRed / 255) * AHP) >= z_rayon then
                   begin
                        Pixel[x_rayon].rgbtRed   := 255;
                        Pixel[x_rayon].rgbtGreen := 255;
                        Pixel[x_rayon].rgbtBlue  := 255;

                        break;
                   End;

                   z_rayon := z_rayon - z_step;
              end;

              z_origine := z_origine + z_step;
         end;
    end;

    ADst.EndUpdate;
End;

Procedure TForm1.bouton_apercuClick(Sender: TObject);

Begin
    Randomize;

    CreationLightmap(image_heightmap.Picture.Bitmap, image_lightmap.Picture.Bitmap, spin_ombrage.Value, spin_angle_rayons.Value, spin_hauteur_max_rayons.Value, spin_hauteur_max_heightmap.Value);

    Image_lightmap.Picture.Bitmap.SaveToFile('light-' + IntTostr(random(1000)) + '.bmp');
end;

End.

